/*******************************************************************************
 * Copyright (c) 2006 Oracle Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Gerry Kessler/Oracle - initial API and implementation
 *    
 ********************************************************************************/

package org.eclipse.jst.jsf.metadataprocessors.internal.provisional.features;

import org.eclipse.jst.jsf.metadataprocessors.internal.provisional.IMetaDataEnabledFeature;

/**
 * Interface providing a default value.
 * 
 * @author Gerry Kessler - Oracle
 * 
 * Experimental
 *
 */
public interface IDefaultValue extends IMetaDataEnabledFeature {
	/**
	 * Default name of property in annotation file to use when supplying default values from meta-data 
	 */
	String DEFAULT_VALUE_PROP_NAME = "default-value";	
	
	/**
	 * @return default value or null if one not defined
	 */
	public String getDefaultValue();
}
